#include <QCoreApplication>
#include <QWebSocketServer>
#include <QWebSocket>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    QWebSocketServer wss("ptnpnx", QWebSocketServer::NonSecureMode);

    if (!wss.listen(QHostAddress::Any, 2525)) {
        qDebug() << "Failed to start websocket server";
        return EXIT_FAILURE;
    }

    QObject::connect(&wss, &QWebSocketServer::newConnection
                     , [&](){
        QWebSocket *pSocket = wss.nextPendingConnection();
        qDebug() << "Service side socket is defined";

        std::string msg(static_cast<long long>(std::pow(2,15)), 'a');
        QString sendString = QString::fromStdString(msg);

        qDebug() << "Server about to send message";
        pSocket->sendTextMessage(sendString.toUtf8());
        qDebug() << "Server send message. Length" << sendString.length();

    }
    );


    QWebSocket ws;
    ws.open(QUrl("ws://localhost:2525"));

    QObject::connect(&ws, &QWebSocket::textMessageReceived
                     , [&](const QString &message){
        qDebug() << "Client side received a text message. Lenght is" << message.length();
    }
    );

//    QObject::connect(&ws, &QWebSocket::binaryMessageReceived
//                     , [&](const QString &message){
//        qDebug() << "Client side received a binary message. Lenght is" << message.length();
//    }
//    );

    return a.exec();
}
